#include <Wire.h>    

#define ADDR 0x50

union Data{
  float Temp;
  int   number;
  unsigned char x[4];
}MyUni;
 
void setup(void)
{
  Serial.begin(9600);
  Wire.begin();

  MyUni.Temp = -100.50;

  writeI2CByte(0 , MyUni.x[0]);
  delay(5);
  writeI2CByte(1 , MyUni.x[1]);
  delay(5);
  writeI2CByte(2 , MyUni.x[2]);
  delay(5);
  writeI2CByte(3 , MyUni.x[3]);
  delay(5);

  MyUni.number = 2021;

  writeI2CByte(4 , MyUni.x[0]);
  delay(5);
  writeI2CByte(5 , MyUni.x[1]);
  delay(5);

  MyUni.x[0] = readI2CByte(0);
  delay(5);
  MyUni.x[1] = readI2CByte(1);
  delay(5);
  MyUni.x[2] = readI2CByte(2);
  delay(5);
  MyUni.x[3] = readI2CByte(3);
  delay(5);

  Serial.print("Float Number:");
  Serial.println(MyUni.Temp);

  MyUni.x[0] = readI2CByte(4);
  delay(5);
  MyUni.x[1] = readI2CByte(5);
  delay(5);

  Serial.print("Int Number:");
  Serial.println(MyUni.number);
}
 
void loop(){}
 
void writeI2CByte(byte data_addr, byte data){
  Wire.beginTransmission(ADDR);
  Wire.write(data_addr);
  Wire.write(data);
  Wire.endTransmission();
}

byte readI2CByte(byte data_addr){
  byte data = NULL;
  Wire.beginTransmission(ADDR);
  Wire.write(data_addr);
  Wire.endTransmission();
  Wire.requestFrom(ADDR, 1); //retrieve 1 returned byte
  delay(1);
  if(Wire.available()){
    data = Wire.read();
  }
  return data;
}
